/*
 * Matrices.java
 *
 * Creado el 9 de marzo de 2006, 18:18
 */


package auxiliar;

/**
 *
 * @author Vctor Jimnez, Antonio Pallars,
 * Mara Jos Cano Vicente, Juan Sebastin Daz Garca,
 * Bernardo Gonzlez Merino
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */

public class Matrices {
        
    static double precision = 5E-16;
    
    public static boolean ifCuadrada(double[][] A) {
        int n = A.length;
        boolean respuesta = true;
        for(int i = 0; i < n; i++) {
            if(A[i].length != n) {
                respuesta = false;
                break;
            }
        }
        return respuesta;
    }
    
    public static boolean ifMatriz(double[][] A) {
        int n = A.length;
        int m = A[0].length;
        boolean respuesta = true;
        
        for(int i = 0; i < n; i++) {
            if(A[i].length != m) {
                respuesta = false;
                break;
            }
        }
        return respuesta;
    }
    
    public static double[][] suma(double[][] A, double[][] B)
            throws ErrorMetodosLineales {
        int n;
        int m;
        double[][] AmasB;
        
        if (!ifMatriz(A)) {
            System.out.println("Error: matriz izquierda mal definida");
            throw new ErrorMetodosLineales();
        }
        if (!ifMatriz(B)) {
            System.out.println("Error: matriz derecha mal definida");
            throw new ErrorMetodosLineales();
        }
        n = B.length;
        m = B[0].length;
        if ((n != A.length) || (m != A[0].length)) {
            System.out.println("Error: dimensiones incompatibles");
            throw new ErrorMetodosLineales();
        }
        
        AmasB = new double[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                AmasB[i][j] = A[i][j] + B[i][j];
            }
        }
        return AmasB;
    }
    
    public static double[] suma(double[] u, double[] v)
            throws ErrorMetodosLineales {
        double[][] A = new double [1][u.length];
        double[][] B = new double [1][v.length];
        
        A[0] = u;
        B[0] = v;
        return suma(A, B)[0];
    }
    
    /**
     * Excepcin ErrorMetodosLineales para ser devuelta por
     * los mtodos de la clase
     */
    public static class  ErrorMetodosLineales extends Exception {
        ErrorMetodosLineales() {
            super("Error: mtodos lineales");
        }
    }
}
